% ex01x03.m
% compute solution of A * x = b with upper triangular matrix A

function x = ex01x03(A,b)
if prod(diag(A)) == 0
  error('Matrix is not regular!')
end
n = size(A,1);
x = zeros(n,1);
for j = 1:n
  for k=1:j-1
    b(j) = b(j) - A(j,k) * x(k);  
  end
  x(j) = b(j) / A(j,j);
end

% rand('seed',0);
% A = triu(rand(5));  % create random lower triangular matrix
% x = rand(5,1);      % create random vector x
% b = A*x;            % create corresponding rhs b = A * x 
% [ex01x03(A,b),x]    % compare computed and exact solution
